#!/boot/home/config/bin/perl -w

use strict;

my $prev_line = "" ;
my $curr_line = "" ;

my $i_StructDepth = 0;
my $b_InStruct = 0;

my %Substitution ;
my %LineSubstitution ;
my %AllSubstitution ;

# replace all the line that contains the pattern
%AllSubstitution= (  '\*.*Function.*:?' => '*/ /*!',
                     '\/\*.*END\ GROUP' => "/\*@}\*/",
                     '\*\.\.\.\.' => '');

# replace a pattern by another and add an empty line after
%LineSubstitution= ( 'Author*.*:' => '\\author ',
      'Creation\ date*.*:' => '\\date ');

# replace a pattern by another
%Substitution= ( '\**.Description*.*:' => "\\brief \n\n",
      '\**.Usage*.*:' => "\\brief \n\n",
      '\**.Modifications*.*:' => "\\brief \n\n",
      '\/\**.BUG*.*:' => "/\*\! \\bug ",
      '\/\**.TODO*.*:' => "/\*\! \\todo ",
      '\**.Param*.*:' => "\\param ",
      '\**.Result*.*:' => "\\return ",);

while( <> )
{
   chomp;
   $curr_line = $_ ;
   my $b_Found;
   $b_Found = 0;

   $_ = $prev_line;
   foreach my $search_string ( keys %LineSubstitution )
   {
      if ( $prev_line =~ /(.*)$search_string/i )
      {
         s/(.*)$search_string/$1$LineSubstitution{$search_string}/;
         $prev_line = "$_\n";
         $b_Found = 1;
      }
   }

   if ( $b_Found == 0 )
   {
      foreach my $search_string ( keys %Substitution )
      {
         if ( $prev_line =~ /(^\s*\**\s*\|?\s*)$search_string/i )
         {
            s/(^\s*\**\s*\|?\s*)$search_string/$1$Substitution{$search_string}/;
            $prev_line = "$_";
            $b_Found = 1;
         }
      }
   }

   if ( $b_Found == 0 )
   {
      foreach my $search_string ( keys %AllSubstitution )
      {
         if ( $prev_line =~ /^([\t ]*)([\t ]*$search_string)(\w*)/ )
         {
            $prev_line = "$AllSubstitution{$search_string}";
            $b_Found = 1;
         }
      }
   }

# New doc group
   if ( $b_Found == 0)
   {
      if ( $prev_line =~ /(.*)\/\*\ GROUP/i )
      {
         s/(^\s*\**\s*\|?\s*)\/\*\ GROUP/$1\/\*\*\ \\addtogroup/;
         print("$_\n");
         $prev_line = "/\*@\{\*/\n";
         $b_Found = 1;
      }
   }

   # typedefs, enum/unions/structs
   if ( $b_Found == 0)
   {
      my $i_OpenCount;
      my $i_CloseCount;
    
      if( $b_InStruct == 0)
      {
         # test start of definition
         if( ( $prev_line =~ /(.*)typedef / ) ||
             ( $prev_line =~ /(.*)struct / ) ||
             ( $prev_line =~ /(.*)enum / ) ||
             ( $prev_line =~ /(.*)union / ) )
         {
            if( tr/;/;/ == 0)
            {
               $b_InStruct = 1;
            }
         }
      }

      # inside struct declaration 
      if( $b_InStruct == 1)   
      {
         $i_OpenCount = tr/{/{/;
         if($i_OpenCount > 0)
         {
            $b_InStruct = 2;
         }
      }
         
      # inside struct
      if( $b_InStruct == 2)   
      {
         $i_OpenCount = tr/{/{/;
         $i_CloseCount = tr/}/}/;
         $i_StructDepth += $i_OpenCount - $i_CloseCount;

         if($i_StructDepth == 0)
         {
            $b_InStruct = 0;
         }
         else
         {
            s/(.*)\/\*\s*/$1\/\*\*\< /;
            $prev_line = "$_";
            $b_Found = 1;
         }
      }
   }

   print("$prev_line\n");
   $prev_line = $curr_line;
}

print($curr_line, "\n");

