#ifndef LIST_MAP_H
#define LIST_MAP_H

/**************************************************
 *            the Beos Reversing Engine           * 
 *                    by Zadig                    *
 *                                                *
 * This file contains headers of the chain-lists  *
 * structures manipulation functions.             *
 **************************************************/
/*******************/
/* GROUP Chainlist */
/*******************/
 
/***********************
 *  Mapping functions  *
 ***********************/ 
extern int32 LIST_AlphaSort(LIST_Mapping *list);
extern int32 LIST_FreeMap(LIST_Mapping *list);
extern int32 LIST_DeleteMap(LIST_Mapping *list, Mapping *mapping);
extern Mapping *LIST_AddMap(LIST_Mapping *list, Mapping map);
extern Mapping *LIST_GetMappingAtAddr(LIST_Mapping *list, uint32 i_Addr);

/*************************
 *  Reference functions  *
 *************************/ 
extern int32 LIST_FreeRef(LIST_Reference *list);
extern int32 LIST_DeleteRef(LIST_Reference *list, int32 i_Index);
extern int32 LIST_AppendRef(LIST_Reference *list, Reference ref);

/**********************
 *  Callee functions  *
 **********************/ 
extern int32 LIST_FreeCallees(LIST_Callee *list);
extern int32 LIST_AddCallee(LIST_Callee *list, Mapping *mapping);

/*************/
/* END GROUP */
/*************/

#endif
