#ifndef GLOBALS_H
#define GLOBALS_H

#include <stdio.h>
#include "zem_errors.h"

#ifdef __BEOS__
#define BEOS_TARGET
#endif

/* defines for target specific code          */
/* HOME is inserted before CONFIG_FILE name  */
#ifdef BEOS_TARGET /* BeOS compilation */

#define CONFIG_FILE     "/config/settings/RevEng_Settings"
#define HEADER_TARGET   "BeOS target    "

#else /* Generic compilation */

#define CONFIG_FILE     "/.revengrc"
#define HEADER_TARGET   "Generic target "

#endif
/* end defines for target specific code*/

/* ctag header */
#define CTAG_HEADER  "!_TAG_FILE_FORMAT	1	//\n\
!_TAG_FILE_SORTED	0	//\n\
!_TAG_PROGRAM_AUTHOR	Zadig	//\n\
!_TAG_PROGRAM_NAME	RevEng	//\n\
!_TAG_PROGRAM_URL	http://reveng.cjb.net	//\n\
!_TAG_PROGRAM_VERSION	%s	//\n"
                    
#define RE_VERSION "1.3.0"

#define STRING_MAX_SIZE    512      /* max size of a string */
#define REG_MAX_SIZE       16       /* max size of a register label */
#define MAX_SECTIONS       30       /* max sections in the file */
#define MAX_REFERENCES     50       /* max references of an object */
#define MAX_PLT_ENTRIES    1500     /* max plt entries in a file */
#define MAX_PARAMS         25       /* max params in a function */
#define MAX_REG_CNTX       200      /* max registers contexts backup */

#define RE_COMMENT_ALIGN   5        /* align comments on 5 chars  */
#define RE_COMMENT_MIN     60       /* minimum comment position   */
#define RE_DISABLED        0xFFFFFFFF

#define RTTI_SYMBOL     "type_info" 
/* macros */
#define INT2STR(i)       ((uint32)( ( ((uint32)(i) & 0xFF) << 24) | \
                                    ( ((uint32)(i) & 0xFF0000) >> 8) |  \
                                    ( ((uint32)(i) & 0xFF00) << 8) | \
                                    ( ((uint32)(i) & 0xFF000000) >> 24) ) )

/* these 2 defines crash with optimization options (don't know why) */
#define STREQ3(s1,s2)    ( ( (*(uint32*)s1) & 0xFFFFFF) == ( (*(uint32*)s2) & 0xFFFFFF) )
#define STREQ4(s1,s2)    ( (*(uint32*)s1) == (*(uint32*)s2) )

/*#define STREQ3(s1,s2)    (strncmp((char*)(s1),s2,3) == 0)
#define STREQ4(s1,s2)    (strncmp((char*)(s1),s2,4) == 0)*/


/* config file section names */
#define CONF_SECTION_CUST_SYM       "[Custom Symbol Table]"
#define CONF_SECTION_CUST_DYN_SYM   "[Custom Dynamic Symbol Table]"
   
/*globals variables*/
#ifdef FLG_DEBUG
extern FILE *dbgFile; /*debugging file*/
#endif

#endif
