#ifndef _TYPES_H
#define _TYPES_H

#ifndef BEOS_TARGET
#include <inttypes.h>

typedef uint8_t    uint8;
typedef int8_t     int8;
typedef uint16_t   uint16;
typedef int16_t    int16;
typedef uint32_t   uint32;
typedef int32_t    int32;
typedef uint64_t   uint64;
typedef int64_t    int64;
#else
#include <SupportDefs.h>
#endif

/* debugging macros */
#ifdef FLG_DEBUG
#include <stdio.h>

extern FILE *dbgFile; /*debugging file*/
  #define DBG_START    dbgFile = fopen("dbgfile.txt","w+")
  #define DBG_PRINT(s) fprintf(dbgFile,s); fflush(dbgFile)
  #define DBG_END      fclose(dbgFile)
#else
  #define DBG_START
  #define DBG_PRINT(s)
  #define DBG_END
#endif
/* end debugging macros */

/* elf types */
typedef uint32    Elf32_Addr;
typedef uint16    Elf32_Half;
typedef uint32    Elf32_Off;
typedef int32     Elf32_Sword;
typedef uint32    Elf32_Word;
/* end elf types */

/***************************
 *  Generic return values  *
 ***************************/ 
#define Z_OK                     	0  /*no error*/
#define Z_TRUE                      1
#define Z_FALSE                     0

#endif
