#ifndef _ZEM_ERRORS_H
#define _ZEM_ERRORS_H

/**********************************************
 *      Executable manipulation library       * 
 *                  by Zadig                  *
 *                                            *
 * This file contains all Errors of the       *
 * project.                                   *
 **********************************************/

/*********************
 *  Errors Families  *
 *********************/
#define FILELIB                     0xFFFE0000
#define ZEMLIB                      0xFFFD0000

/*****************
 *  FILE Errors  *
 *****************/
#define FILE_ERROR_READ            (FILELIB | 0x0001)  
#define FILE_ERROR_WRITE           (FILELIB | 0x0002) 
#define FILE_ERROR_OPEN            (FILELIB | 0x0003)
#define FILE_ERROR_CLOSE           (FILELIB | 0x0004)  
#define FILE_ERROR_PARAMETER       (FILELIB | 0x0005) 
#define FILE_ERROR_EOF             (FILELIB | 0x0006) 
#define FILE_ERROR_OVERFLOW        (FILELIB | 0x0007) 
#define FILE_ERROR_SEEK            (FILELIB | 0x0008)

/****************
 *  ZEM Errors  *
 ****************/
#define ZEM_ERROR_NOT_FOUND        (ZEMLIB | 0x0001)  
#define ZEM_ERROR_PARAM            (ZEMLIB | 0x0002)   
#define ZEM_ERROR_MALLOC           (ZEMLIB | 0x0003)   
#define ZEM_ERROR_MFREE            (ZEMLIB | 0x0004)   
#define ZEM_ERROR_ENTRY            (ZEMLIB | 0x0005)

#endif
